// SASImportView.h : interface of the CSASImportView class
//


#pragma once


class CSASImportView : public CView
{
protected: // create from serialization only
	CSASImportView();
	DECLARE_DYNCREATE(CSASImportView)

// Attributes
public:
	CSASImportDoc* GetDocument() const;

// Operations
public:

// Overrides
public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);

// Implementation
public:
	virtual ~CSASImportView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in SASImportView.cpp
inline CSASImportDoc* CSASImportView::GetDocument() const
   { return reinterpret_cast<CSASImportDoc*>(m_pDocument); }
#endif

